#include <windows.h>
#include <stdio.h>

#include "avi_utils.h"
#include "aviwriter.h"

HDC hdc = 0;
void *bits = NULL;
HBITMAP hbm = 0;
HAVI avi = 0;
int bufsize = 0;

void CreateAviFile(char *filename, int width, int height)
{
  HDC hdcscreen;
  hdcscreen = GetDC(0);
  hdc = CreateCompatibleDC(hdcscreen);
  ReleaseDC(0, hdcscreen);


  BITMAPINFO bi;
  ZeroMemory(&bi, sizeof(bi));
  BITMAPINFOHEADER &bih = bi.bmiHeader;
  bih.biSize = sizeof(bih);
  bih.biWidth = width;
  bih.biHeight = height;
  bih.biPlanes = 1;
  bih.biBitCount = 24;
  bih.biCompression = BI_RGB;
  bih.biSizeImage = 0;//((bih.biWidth*bih.biBitCount/8+3)&0xFFFFFFFC)*bih.biHeight;
  bih.biXPelsPerMeter = 10000;
  bih.biYPelsPerMeter = 10000;
  bih.biClrUsed = 0;
  bih.biClrImportant = 0;

  bufsize = width * height * 3;

  hbm = CreateDIBSection(hdc,(BITMAPINFO*)&bih, DIB_RGB_COLORS, &bits, NULL, 0);
  avi = CreateAvi(filename, 1000/15, NULL);


}

void SelectCompressor(char *filename)
{
 {
   AVICOMPRESSOPTIONS opts;
   ZeroMemory(&opts,sizeof(opts));
   SetAviVideoCompression(avi, hbm, &opts, true, 0);

   if(filename)
   {
     FILE *optfile = fopen(filename, "wb");
     fwrite(&opts, 1, sizeof(opts), optfile);
     fclose(optfile);
   }

 }
}

void LoadOptions(char *filename)
{
 {
   AVICOMPRESSOPTIONS opts;
   ZeroMemory(&opts,sizeof(opts));

   FILE *optfile = fopen(filename, "rb");
   fread(&opts, 1, sizeof(opts), optfile);
   fclose(optfile);

   SetAviVideoCompression(avi, hbm, &opts, false, 0);

 }
}

void AddFrame(void *buffer)
{
  memcpy(bits, buffer, bufsize);
  AddAviFrame(avi, hbm);
}

void CloseAviFile()
{
  CloseAvi(avi);
  DeleteDC(hdc);
  DeleteObject(hbm);
}


